unit hiCursor;

interface

uses Windows,Kol,Share,Debug;

type
  THICursor = class(TDebug)
   private
    Bmp: PBitmap;
    Pos, HotSpot: TPoint; 
    flag: integer;
   public
    _prop_BkColor:integer;
    _event_onGet: THI_Event;
       
    destructor Destroy; override;
    procedure _work_doGet(var _Data:TData; Index:word);
    procedure _var_Bitmap(var _Data:TData; Index:word);
    procedure _var_Width(var _Data:TData; Index:word);
    procedure _var_Height(var _Data:TData; Index:word);
    procedure _var_CursorX(var _Data:TData; Index:word);
    procedure _var_CursorY(var _Data:TData; Index:word);
    procedure _var_HotSpotX(var _Data:TData; Index:word);
    procedure _var_HotSpotY(var _Data:TData; Index:word);
    procedure _var_Visible(var _Data:TData; Index:word);
  end;

implementation

{$ifndef NO_SMART_LINK}
function GetCursorInfo(var pci: TCursorInfo): BOOL; stdcall; external user32 name 'GetCursorInfo';
{$endif NO_SMART_LINK}

destructor THICursor.Destroy;
begin
    Bmp.free;
    inherited;
end;

procedure THICursor._work_doGet;
var ci: TCursorInfo;
    ii: TIconInfo;
    Icon:PIcon;
begin
    if Bmp <> nil then Bmp.Free; 
    Bmp := NewBitmap(0,0);
    Bmp.PixelFormat := pf32bit;
    ci.cbSize:=SizeOf(ci);
    GetCursorInfo(ci);
    flag := ci.flags;
    if flag = 0 then
     begin
      Bmp.Clear;
      GetCursorPos(Pos);
      HotSpot := MakePoint(0,0);
     end
    else
     begin
      Icon := NewIcon;
      Icon.Handle := ci.hCursor;
      GetIconInfo(ci.hCursor, ii);    
      HotSpot.X := ii.xHotspot;
      HotSpot.Y := ii.yHotspot;
      Pos := ci.ptScreenPos;
      bmp.Handle := Icon.Convert2Bitmap(_prop_BkColor);
      Icon.Free;
     end;
      _hi_onEvent(_event_onGet);

end;

procedure THICursor._var_Bitmap;
begin
    dtBitmap(_Data,Bmp);
end;

procedure THICursor._var_Width;
begin
   dtInteger(_Data,Bmp.Width);
end;

procedure THICursor._var_Height;
begin
   dtInteger(_Data,Bmp.Height);
end;

procedure THICursor._var_CursorX;
begin
   dtInteger(_Data,Pos.X);
end;

procedure THICursor._var_CursorY;
begin
   dtInteger(_Data,Pos.Y);
end;

procedure THICursor._var_HotSpotX;
begin
   dtInteger(_Data,HotSpot.X);
end;

procedure THICursor._var_HotSpotY;
begin
   dtInteger(_Data,HotSpot.Y);
end;

procedure THICursor._var_Visible;
begin
    dtInteger(_Data, flag);
end;

end.
